]> granicus.if.org Git - linux-pam/commitdiff
Relevant BUGIDs:
authorThorsten Kukuk <kukuk@thkukuk.de>
Tue, 26 Jun 2007 10:44:28 +0000 (10:44 +0000)
committerThorsten Kukuk <kukuk@thkukuk.de>
Tue, 26 Jun 2007 10:44:28 +0000 (10:44 +0000)
Purpose of commit: bugfix

Commit summary:
---------------

2007-06-26  Thorsten Kukuk  <kukuk@thkukuk.de>

        * modules/pam_limits/pam_limits.c (process_limit): Check upper and
        lower limit of nice value, fix off-by-one in conversation to rlim_t.
        * xtests/Makefile.am: Add new pam_limits test case.
        * xtests/limits.conf: New, config file for test case.
        * xtests/pam_limits1.c: New, test case for RLIMIT_NICE.
        * xtests/pam_limits1.sh: Likewise.
        * xtests/pam_limits1.pamd: Likewise.

ChangeLog
modules/pam_limits/pam_limits.c
xtests/Makefile.am
xtests/run-xtests.sh
xtests/tst-pam_limits1.c [new file with mode: 0644]
xtests/tst-pam_limits1.pamd [new file with mode: 0644]
xtests/tst-pam_limits1.sh [new file with mode: 0755]

index 3e18b430e694ae31d3fd5bd9466dfa69fb167ef2..9a9bc72fdd4d5b43995c1dbd6181c10ff508b60f 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,13 @@
+2007-06-26  Thorsten Kukuk  <kukuk@thkukuk.de>
+
+       * modules/pam_limits/pam_limits.c (process_limit): Check upper and
+       lower limit of nice value, fix off-by-one in conversation to rlim_t.
+       * xtests/Makefile.am: Add new pam_limits test case.
+       * xtests/limits.conf: New, config file for test case.
+       * xtests/pam_limits1.c: New, test case for RLIMIT_NICE.
+       * xtests/pam_limits1.sh: Likewise.
+       * xtests/pam_limits1.pamd: Likewise.
+
 2007-06-25  Thorsten Kukuk  <kukuk@thkukuk.de>
 
        * modules/pam_access/pam_access.c (list_match): Use saveptr of strtok_r
index bf6f09df55570ca6a96bd20e6355e5863a615f27..b7ed0adc9b66e4bfc9fdb632a5062bdd1dd8e829 100644 (file)
@@ -401,7 +401,9 @@ process_limit (const pam_handle_t *pamh, int source, const char *lim_type,
        case RLIMIT_NICE:
         if (int_value > 19)
            int_value = 19;
-        rlimit_value = 19 - int_value;
+        if (int_value < -20)
+          int_value = -20;
+        rlimit_value = 20 - int_value;
 #endif
          break;
     }
index 0fc76b01dc72dc1b70f69d838737db5aa3a4222d..f2e48c5e1a268051c7facb228313bd1f1e7476cc 100644 (file)
@@ -17,13 +17,14 @@ EXTRA_DIST = run-xtests.sh tst-pam_dispatch1.pamd tst-pam_dispatch2.pamd \
        access.conf tst-pam_access1.pamd tst-pam_access1.sh \
        tst-pam_access2.pamd tst-pam_access2.sh \
        tst-pam_access3.pamd tst-pam_access3.sh \
-       tst-pam_access4.pamd tst-pam_access4.sh
+       tst-pam_access4.pamd tst-pam_access4.sh \
+       limits.conf tst-pam_limits1.pamd tst-pam_limits1.sh
 
 XTESTS = tst-pam_dispatch1 tst-pam_dispatch2 tst-pam_dispatch3 \
        tst-pam_dispatch4 tst-pam_cracklib1 tst-pam_cracklib2 \
        tst-pam_unix1 tst-pam_unix2 tst-pam_unix3 \
        tst-pam_access1 tst-pam_access2 tst-pam_access3 \
-       tst-pam_access4
+       tst-pam_access4 tst-pam_limits1
 
 noinst_PROGRAMS = $(XTESTS)
 
index 9670bd7ac3f74fde0c96fd09ce840df44387fc28..76daba221517f2b749bec9b376b62a9cf74872e2 100755 (executable)
@@ -18,6 +18,8 @@ all=0
 mkdir -p /etc/security
 cp /etc/security/access.conf /etc/security/access.conf-pam-xtests
 install -m 644 "${SRCDIR}"/access.conf /etc/security/access.conf
+cp /etc/security/limits.conf /etc/security/limits.conf-pam-xtests
+install -m 644 "${SRCDIR}"/limits.conf /etc/security/limits.conf
 for testname in $XTESTS ; do
          install -m 644 "${SRCDIR}"/$testname.pamd /etc/pam.d/$testname
          if test -x "${SRCDIR}"/$testname.sh ; then
@@ -36,6 +38,7 @@ for testname in $XTESTS ; do
          rm -f /etc/pam.d/$testname
 done
 mv /etc/security/access.conf-pam-xtests /etc/security/access.conf
+mv /etc/security/limits.conf-pam-xtests /etc/security/limits.conf
 if test "$failed" -ne 0; then
          echo "==================="
          echo "$failed of $all tests failed"
diff --git a/xtests/tst-pam_limits1.c b/xtests/tst-pam_limits1.c
new file mode 100644 (file)
index 0000000..6331450
--- /dev/null
@@ -0,0 +1,148 @@
+/*
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, and the entire permission notice in its entirety,
+ *    including the disclaimer of warranties.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote
+ *    products derived from this software without specific prior
+ *    written permission.
+ *
+ * ALTERNATIVELY, this product may be distributed under the terms of
+ * the GNU Public License, in which case the provisions of the GPL are
+ * required INSTEAD OF the above restrictions.  (This clause is
+ * necessary due to a potential bad interaction between the GPL and
+ * the restrictions contained in a BSD-style copyright.)
+ *
+ * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
+ * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
+ * OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+  test case:
+
+  Check the following line in limits.conf:
+  *               soft    nice     19
+  *               hard    nice     -20
+
+  getrlimit should return soft=1 and hard=40.
+*/
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include <sys/time.h>
+#include <sys/resource.h>
+
+#include <security/pam_appl.h>
+
+/* A conversation function which uses an internally-stored value for
+   the responses. */
+static int
+fake_conv (int num_msg, const struct pam_message **msgm UNUSED,
+          struct pam_response **response, void *appdata_ptr UNUSED)
+{
+  struct pam_response *reply;
+  int count;
+
+  /* Sanity test. */
+  if (num_msg <= 0)
+    return PAM_CONV_ERR;
+
+  /* Allocate memory for the responses. */
+  reply = calloc (num_msg, sizeof (struct pam_response));
+  if (reply == NULL)
+    return PAM_CONV_ERR;
+
+  /* Each prompt elicits the same response. */
+  for (count = 0; count < num_msg; ++count)
+    {
+      reply[count].resp_retcode = 0;
+      reply[count].resp = strdup ("!!");
+    }
+
+  /* Set the pointers in the response structure and return. */
+  *response = reply;
+  return PAM_SUCCESS;
+}
+
+static struct pam_conv conv = {
+    fake_conv,
+    NULL
+};
+
+int
+main(int argc, char *argv[])
+{
+  pam_handle_t *pamh = NULL;
+  const char *user="tstpamlimits";
+  int retval;
+  int debug = 0;
+
+  if (argc > 1 && strcmp (argv[1], "-d") == 0)
+    debug = 1;
+
+  retval = pam_start("tst-pam_limits1", user, &conv, &pamh);
+  if (retval != PAM_SUCCESS)
+    {
+      if (debug)
+       fprintf (stderr, "pam_limits1: pam_start returned %d\n", retval);
+      return 1;
+    }
+
+  retval = pam_set_item (pamh, PAM_TTY, "/dev/tty1");
+  if (retval != PAM_SUCCESS)
+    {
+      if (debug)
+       fprintf (stderr,
+                "pam_limits1: pam_set_item(PAM_TTY) returned %d\n",
+                retval);
+      return 1;
+    }
+
+  retval = pam_open_session (pamh, 0);
+  if (retval != PAM_SUCCESS)
+    {
+      if (debug)
+       fprintf (stderr, "pam_limits1: pam_open_session returned %d\n",
+                retval);
+      return 1;
+    }
+
+  struct rlimit rlim;
+
+  getrlimit (RLIMIT_NICE, &rlim);
+
+  if (rlim.rlim_cur != 1 && rlim.rlim_max != 40)
+    {
+      if (debug)
+       fprintf (stderr, "pam_limits1: getrlimit failed, soft=%d, hard=%d\n",
+                rlim.rlim_cur, rlim.rlim_max);
+      return 1;
+    }
+
+  retval = pam_end (pamh,retval);
+  if (retval != PAM_SUCCESS)
+    {
+      if (debug)
+       fprintf (stderr, "pam_limits1: pam_end returned %d\n", retval);
+      return 1;
+    }
+  return 0;
+}
diff --git a/xtests/tst-pam_limits1.pamd b/xtests/tst-pam_limits1.pamd
new file mode 100644 (file)
index 0000000..206ef1f
--- /dev/null
@@ -0,0 +1,6 @@
+#%PAM-1.0
+auth     required       pam_permit.so
+account  required       pam_permit.so
+password required       pam_permit.so
+session  required       pam_limits.so
+
diff --git a/xtests/tst-pam_limits1.sh b/xtests/tst-pam_limits1.sh
new file mode 100755 (executable)
index 0000000..4faa822
--- /dev/null
@@ -0,0 +1,7 @@
+#!/bin/bash
+
+/usr/sbin/useradd -p '!!' tstpamlimits
+./tst-pam_limits1
+RET=$?
+/usr/sbin/userdel -r tstpamlimits 2> /dev/null
+exit $RET